<?php
//
// (с) 2007-2016 InstantCMS Ver 1.10.7, from InstantCMS Team (www.instantcms.ru)
// (c) 2016-202X Public fork iCMS Ver 1.10.7.XXX from InstantCMS members (www.icms.su)
// Licensed by GNU/GPL Ver.2
//

if(!defined('VALID_CMS_ADMIN')) { die('ACCESS DENIED'); }

function createMenuItem($menu, $id, $title){

    $inCore = cmsCore::getInstance();
	$inDB = cmsDatabase::getInstance();

	$rootid = $inDB->getNsRootCatId('cms_menu');

	$ns = $inCore->nestedSetsInit('cms_menu');
	$myid = $ns->AddNode($rootid);

    $link = $inCore->getMenuLink('category', $id);

	$sql = "UPDATE cms_menu
			SET menu='$menu',
				title='$title',
				link='$link',
				linktype='category',
				linkid='$id',
				target='_self',
				published='1',
				template='0',
				access_list='',
				iconurl=''
			WHERE id = '$myid'";

	$inDB->query($sql);
	return true;
}

function applet_cats(){

    $inCore = cmsCore::getInstance();
    $inDB   = cmsDatabase::getInstance();

	global $_LANG;

    $GLOBALS['cp_page_title'] = $_LANG['AD_ARTICLES']	;
    cpAddPathway($_LANG['AD_ARTICLES'], 'index.php?view=tree');

    cmsCore::loadModel('content');
    $model = new cms_model_content();

	$do = cmsCore::request('do', 'str', 'add');
	$id = cmsCore::request('id', 'int', -1);

    define('IS_BILLING', $inCore->isComponentInstalled('billing'));
    if (IS_BILLING) { cmsCore::loadClass('billing'); }

	if ($do == 'delete'){
        $is_with_content = cmsCore::inRequest('content');
        $model->deleteCategory($id, $is_with_content);
		cmsCore::addSessionMessage(($is_with_content ? $_LANG['AD_CATEGORY_REMOVED'] : $_LANG['AD_CATEGORY_REMOVED_NOT_ARTICLE']), 'success');
		cmsCore::redirect('?view=tree');
	}

	if ($do == 'update'){

        if (!cmsUser::checkCsrfToken()) { cmsCore::error404(); }

        $category['id']			 = cmsCore::request('id', 'int', 0);
        $category['title']		 = cmsCore::request('title', 'str', $_LANG['AD_SECTION_UNTITLED']);
        $category['parent_id']	 = cmsCore::request('parent_id', 'int');
        $category['description'] = cmsCore::request('description', 'html');
        $category['description'] = $inDB->escape_string($category['description']);
        $category['published'] 	 = cmsCore::request('published', 'int', 0);
        $category['showdate'] 	 = cmsCore::request('showdate', 'int', 0);
        $category['showcomm'] 	 = cmsCore::request('showcomm', 'int', 0);
        $category['orderby'] 	 = cmsCore::request('orderby', 'str');
        $category['orderto']	 = cmsCore::request('orderto', 'str');
        $category['modgrp_id'] 	 = cmsCore::request('modgrp_id', 'int', 0);
        $category['maxcols'] 	 = cmsCore::request('maxcols', 'int', 0);
        $category['showtags'] 	 = cmsCore::request('showtags', 'int', 0);
        $category['showrss']     = cmsCore::request('showrss', 'int', 0);
        $category['showdesc']    = cmsCore::request('showdesc', 'int', 0);
        $category['is_public']   = cmsCore::request('is_public', 'int', 0);
        $category['url']         = cmsCore::request('url', 'str');
        $category['pagetitle']   = cmsCore::request('pagetitle', 'str', '');
        $category['meta_desc']   = cmsCore::request('meta_desc', 'str');
        $category['meta_keys']   = cmsCore::request('meta_keys', 'str');

        if ($category['url']) { $category['url'] = cmsCore::strToURL($category['url'], $model->config['is_url_cyrillic']); }
        $category['tpl'] 		 = cmsCore::request('tpl', 'str', 'com_content_view.tpl');

        $category['cost']        = cmsCore::request('cost', 'str', '');
        if (!is_numeric($category['cost'])) { $category['cost'] = ''; }

        $album = array();
        $album['id']      = cmsCore::request('album_id', 'int', 0);
        $album['header']  = cmsCore::request('album_header', 'str', '');
        $album['orderby'] = cmsCore::request('album_orderby', 'str', '');
        $album['orderto'] = cmsCore::request('album_orderto', 'str', '');
        $album['maxcols'] = cmsCore::request('album_maxcols', 'int', 0);
        $album['max']	  = cmsCore::request('album_max', 'int', 0);

        if($album['id']){
            $category['photoalbum'] = serialize($album);
        }else{
            $category['photoalbum'] = '';
        }

        // получаем старую категорию
        $old = $inDB->get_fields('cms_category', "id='{$category['id']}'", '*');
        if(!$old){ cmsCore::error404(); }

        // если сменили категорию
        if($old['parent_id'] != $category['parent_id']){
            // перемещаем ее в дереве
            $inCore->nestedSetsInit('cms_category')->MoveNode($category['id'], $category['parent_id']);
            // обновляем сеолинки категорий
            $inDB->updateNsCategorySeoLink('cms_category', $category['id'], $model->config['is_url_cyrillic']);
            // Обновляем ссылки меню на категории
            $model->updateCatMenu();
            // обновляем сеолинки всех вложенных статей
            $model->updateArticlesSeoLink($category['id']);
            cmsCore::addSessionMessage($_LANG['AD_CATEGORY_NEW_URL'], 'info');
        }

        $inDB->update('cms_category', $category, $category['id']);

        // если пришел запрос на обновление ссылок
        // и категория не менялась - если менялась, мы выше все обновили
        if(cmsCore::inRequest('update_seolink') && ($old['parent_id'] == $category['parent_id'])){
            // обновляем сеолинки категорий
            $inDB->updateNsCategorySeoLink('cms_category', $category['id'], $model->config['is_url_cyrillic']);
            // Обновляем ссылки меню на категории
            $model->updateCatMenu();
            // обновляем сеолинки всех вложенных статей
            $model->updateArticlesSeoLink($category['id']);
            cmsCore::addSessionMessage($_LANG['AD_SECTION_AND_ARTICLES_NEW_URL'], 'info');
        }

        if(!cmsCore::request('is_access', 'int', 0)){
            $showfor = $_REQUEST['showfor'];
            cmsCore::setAccess($category['id'], $showfor, 'category');
        }else{
            cmsCore::clearAccess($category['id'], 'category');
        }

        cmsCore::addSessionMessage($_LANG['AD_CATEGORY_SAVED'], 'success');

        if(empty($_SESSION['editlist'])){
            cmsCore::redirect('?view=tree&cat_id='.$category['id']);
        }else{
            cmsCore::redirect('?view=tree');
        }

	}

	if($do == 'submit'){

        if(!cmsUser::checkCsrfToken()){ cmsCore::error404(); }

        $category['title']       = cmsCore::request('title', 'str', $_LANG['AD_CATEGORY_UNTITLED']);
        $category['url']         = cmsCore::request('url', 'str');
		if($category['url']){ $category['url'] = cmsCore::strToURL($category['url']); }
        $category['parent_id']   = cmsCore::request('parent_id', 'int');
        $category['description'] = cmsCore::request('description', 'html');
        $category['description'] = $inDB->escape_string($category['description']);
        $category['published']   = cmsCore::request('published', 'int', 0);
        $category['showdate']    = cmsCore::request('showdate', 'int', 0);
        $category['showcomm']    = cmsCore::request('showcomm', 'int', 0);
        $category['orderby']     = cmsCore::request('orderby', 'str');
        $category['orderto']     = cmsCore::request('orderto', 'str');
        $category['modgrp_id']   = cmsCore::request('modgrp_id', 'int', 0);
        $category['maxcols']     = cmsCore::request('maxcols', 'int', 0);
        $category['showtags']    = cmsCore::request('showtags', 'int', 0);
        $category['showrss']     = cmsCore::request('showrss', 'int', 0);
        $category['showdesc']    = cmsCore::request('showdesc', 'int', 0);
        $category['is_public']   = cmsCore::request('is_public', 'int', 0);
        $category['tpl']         = cmsCore::request('tpl', 'str', 'com_content_view.tpl');
        $category['pagetitle']   = cmsCore::request('pagetitle', 'str', '');
        $category['meta_desc']   = cmsCore::request('meta_desc', 'str');
        $category['meta_keys']   = cmsCore::request('meta_keys', 'str');

        $category['cost']        = cmsCore::request('cost', 'str', 0);
        if(!is_numeric($category['cost'])){ $category['cost'] = ''; }

        $album = array();
        $album['id']      = cmsCore::request('album_id', 'int', 0);
        $album['header']  = cmsCore::request('album_header', 'str', '');
        $album['orderby'] = cmsCore::request('album_orderby', 'str', '');
        $album['orderto'] = cmsCore::request('album_orderto', 'str', '');
        $album['maxcols'] = cmsCore::request('album_maxcols', 'int', 0);
        $album['max']	  = cmsCore::request('album_max', 'int', 0);

		if($album['id']){
	        $category['photoalbum'] = serialize($album);
		}else{
			$category['photoalbum'] = '';
		}

        $ns = $inCore->nestedSetsInit('cms_category');
        $category['id'] = $ns->AddNode($category['parent_id']);

        $category['seolink'] = cmsCore::generateCatSeoLink($category, 'cms_category', $model->config['is_url_cyrillic']);

        if($category['id']){

			$inDB->update('cms_category', $category, $category['id']);

			if(!cmsCore::request('is_access', 'int', 0)){
				$showfor = $_REQUEST['showfor'];
				cmsCore::setAccess($category['id'], $showfor, 'category');
			}else{
				cmsCore::clearAccess($category['id'], 'category');
            }
        }

        $inmenu = cmsCore::request('createmenu', 'str', '');

        if($inmenu){
            createMenuItem($inmenu, $category['id'], $category['title']);
        }

		cmsCore::addSessionMessage($_LANG['AD_CATEGORY_ADD'], 'success');

		cmsCore::redirect('?view=tree');

    }

   if($do == 'add' || $do == 'edit'){

	 	require('../includes/jwtabs.php');
		$GLOBALS['cp_page_head'][] = jwHeader();

 		$toolmenu = array();
		$toolmenu[0]['icon'] = 'save.gif';
		$toolmenu[0]['title'] = $_LANG['SAVE'];
		$toolmenu[0]['link'] = 'javascript:document.addform.submit();';

		$toolmenu[1]['icon'] = 'cancel.gif';
		$toolmenu[1]['title'] = $_LANG['CANCEL'] ;
		$toolmenu[1]['link'] = 'javascript:history.go(-1);';

		cpToolMenu($toolmenu);
        $menu_list = cpGetList('menu');

		if($do=='add'){
			 echo '<h3>'.$_LANG['AD_CREATE_SECTION'].'</h3>';
 	 		 cpAddPathway($_LANG['AD_CREATE_SECTION'], 'index.php?view=cats&do=add');
			 $mod['tpl'] = 'com_content_view.tpl';
		}else{
			if(!empty($_REQUEST['multiple'])){
				if (!empty($_REQUEST['item'])){
					$_SESSION['editlist'] = $_REQUEST['item'];
				}else{
					echo '<p class="error">'.$_LANG['AD_NO_SELECT_OBJECTS'].'</p>';
					return;
				}
			}

			 $remainder = '';

			 if(!empty($_SESSION['editlist'])){
				$id = array_shift($_SESSION['editlist']);
				if(sizeof($_SESSION['editlist'])==0){
				   unset($_SESSION['editlist']); 
				}else{
				   $remainder = '('.$_LANG['AD_NEXT_IN'].sizeof($_SESSION['editlist']).')';
				}
			 }else{
			    $id = (int)$_REQUEST['id'];
			 }

			 $sql = "SELECT * FROM cms_category WHERE id = $id LIMIT 1";
			 $result = $inDB->query($sql) ;
			 if($inDB->num_rows($result)){
				$mod = $inDB->fetch_assoc($result);
				if(@$mod['photoalbum']){ $mod['photoalbum'] = unserialize($mod['photoalbum']); }
			 }
			 echo '<h3>'.$_LANG['AD_EDIT_SECTION'].$remainder.'</h3>';
			 cpAddPathway($mod['title'], 'index.php?view=cats&do=edit&id='.$mod['id']);
		}
	?>

	<form id="addform" name="addform" method="post" action="index.php">
		<input type="hidden" name="csrf_token" value="<?php echo cmsUser::getCsrfToken(); ?>">
		<input type="hidden" name="view" value="cats">
		<table class="adminbody">
			<tr>
				<!-- главная ячейка -->
				<td class="mainlist">
					<table>
						<tr>
							<td>
								<div class="tabtitle"> <?php echo $_LANG['AD_TITLE_PARTITION']; ?> </div>
								<?php printLangPanel('content_category', @$mod['id'], 'title'); ?>
								<input class="fullsize" name="title" type="text" id="title" value="<?php if(!empty($mod['title'])){ echo htmlspecialchars($mod['title']); } ?> ">
							</td>
							<td style="width:200px">
								<div class="tabtitle"> <?php echo $_LANG['AD_TEMPLATE_PARTITION'];?> </div>
								<input class="fullsize" name="tpl" type="text" value="<?php echo @$mod['tpl']; ?>">
							</td>
						</tr>
					</table>
                    <div class="tabtitle"> <?php echo $_LANG['AD_PARENT_PARTITION']; ?> </div>
					<div>
                        <select class="selectbox" name="parent_id" size="12" id="parent_id" onchange="if($('option:selected',this).data('nsleft')>=' <?php echo $mod['NSLeft']; ?> ' && $('option:selected',this).data('nsright')<=' <?php echo $mod['NSRight']; ?> '){ $('.parent_notice').show();$('#add_mod').prop('disabled', true); } else { $('.parent_notice').hide();$('#add_mod').prop('disabled', false); }">
							<?php $rootid = $inDB->getNsRootCatId('cms_category'); ?>
							<option value="<?php echo $rootid; ?>" <?php if (@$mod['parent_id']==$rootid || empty($mod['parent_id'])) { echo 'selected="selected"'; } ?> >
								<?php echo $_LANG['AD_SECTION']; ?>
							</option>
							<?php if (!empty($mod['parent_id'])){
								echo $inCore->getListItemsNS('cms_category', $mod['parent_id']);
							} else {
								echo $inCore->getListItemsNS('cms_category');
							} ?>
						</select>
					</div>

                    <div class="tabtitle"> <?php echo $_LANG['AD_SECTION_DESCRIPT']; ?> <?php printLangPanel('content_category', @$mod['id'], 'description'); ?> </div>
					<div> <?php if(empty($mod['description'])){ $mod['description'] = ''; } $inCore->insertEditor('description', $mod['description'], '250', '100%'); ?> </div>
				</td>
				
				<!-- боковая -->
				<td class="greytabswide">
					<?php ob_start(); ?>
					
					{tab= <?php echo $_LANG['AD_TAB_PUBLISH']; ?> }
						<div>
							<input class="checklist" type="checkbox" name="published" id="published" value="1" <?php if( (!empty($mod['published']) AND $mod['published']) || $do=='add'){ echo 'checked="checked"'; } ?> >
							<label for="published"> <?php echo $_LANG['AD_PUBLIC_SECTION']; ?> </label>
						</div>
						
						<div style=" <?php if ($do=='edit') {  ?> display:none; <?php } ?> " class="url_cat">
							<div class="tabtitle"> <?php echo $_LANG['AD_SECTION_URL']; ?> <br> <span class="hinttext"> <?php echo $_LANG['AD_FROM_TITLE']; ?> </span> </div>
							<input class="fullsize" type="text" name="url" value="<?php if(!empty($mod['url'])){ echo $mod['url']; } ?>">
						</div>
						
						<?php if ($do=='edit') { ?>
							<div class="fieldtop">
								<input class="checklist" type="checkbox" name="update_seolink" id="update_seolink" value="1" onclick="$('.url_cat').slideToggle('fast');">
								<label for="update_seolink"> <?php echo $_LANG['AD_NEW_LINK']; ?> </label>
								
								<div class="url_cat" style="display:none;">
									<div class="tabtitle"> <span style="color:#f50707"> <?php echo $_LANG['ATTENTION']; ?>! </span> <?php echo $_LANG['AD_NO_LINKS']; ?> </div>
								</div>
							</div>
						<?php } ?>

						<div class="tabtitle"> <?php echo $_LANG['AD_SORT_ARTICLES']; ?> </div>
						<div class="fielddown">
							<select name="orderby" id="orderby">
								<option value="pubdate" <?php if (@$mod['orderby']=='pubdate') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_CALENDAR']; ?> </option>
								<option value="title" <?php if (@$mod['orderby']=='title') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_TITLE']; ?> </option>
								<option value="ordering" <?php if (@$mod['orderby']=='ordering') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_ORDER']; ?> </option>
								<option value="hits" <?php if (@$mod['orderby']=='hits') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_VIEWS']; ?> </option>
							</select>
							
							<select name="orderto" id="orderto">
								<option value="ASC" <?php if (@$mod['orderto']=='ASC') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_INCREMENT']; ?> </option>
								<option value="DESC" <?php if (@$mod['orderto']=='DESC') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_DECREMENT']; ?> </option>
							</select>
						</div>

						<div class="tabtitle"> <?php echo $_LANG['AD_HOW_MANY_COLUMNS']; ?> </div>
						<div class="fielddown">
							<?php if (empty($mod['maxcols'])) { $mod['maxcols'] = 1; } ?>
							<input class="uispin" name="maxcols" type="text" id="maxcols" value="<?php echo @$mod['maxcols']; ?> ">
						</div>

						<div class="tabtitle"> <?php echo $_LANG['AD_HOW_PUBLISH_SET'];?> </div>
						<div>
							<input class="checklist" type="checkbox" name="showdesc" id="showdesc" value="1" <?php if( !empty($mod['showdesc']) || $do=='add'){ echo 'checked="checked"'; } ?> >
							<label for="showdesc"> <?php echo $_LANG['AD_PREVIEW']; ?> </label>
						</div>
                        <div>
							<input class="checklist" type="checkbox" name="showdate" id="showdate" value="1" <?php if( !empty($mod['showdate']) || $do=='add'){ echo 'checked="checked"'; } ?> >
							<label for="showdate"> <?php echo $_LANG['AD_CALENDAR_VIEW']; ?> </label>
						</div>
                        <div>
							<input class="checklist" type="checkbox" name="showcomm" id="showcomm" value="1" <?php if( !empty($mod['showcomm'])  || $do=='add'){ echo 'checked="checked"'; } ?> >
							<label for="showcomm"> <?php echo $_LANG['AD_HOW_MANY_COMENTS']; ?> </label>
						</div>
                        <div>
							<input class="checklist" type="checkbox" name="showtags" id="showtags" value="1" <?php if( !empty($mod['showtags']) || $do=='add'){ echo 'checked="checked"'; } ?> >
							<label for="showtags"> <?php echo $_LANG['AD_HOW_MANY_TAGS']; ?> </label>
						</div>
                        <div class="fielddown">
							<input class="checklist" type="checkbox" name="showrss" id="showrss" value="1" <?php if( !empty($mod['showrss']) || $do=='add') { echo 'checked="checked"'; } ?> >
							<label for="showrss"> <?php echo $_LANG['AD_RSS_VIEW']; ?> </label>
						</div>
						
						<?php if ($do=='add'){ ?>
							<div class="tabtitle"> <?php echo $_LANG['AD_CREATE_LINK']; ?> </div>
							<div>
								<select name="createmenu" id="createmenu">
									<option value="0" selected="selected"> <?php echo $_LANG['AD_DONT_CREATE']; ?> </option>
									<?php foreach ($menu_list as $menu) { ?>
										<option value="<?php echo $menu['id']; ?>"> <?php echo $menu['title']; ?> </option>
									<?php } ?>
								</select>
							</div>
						<?php } ?>
						
					{tab= <?php echo $_LANG['AD_FOTO']; ?> }
						<div class="tabtitle"> <?php echo $_LANG['AD_PHOTOALBUM_CONNECT']; ?> <br> <span class="hinttext"> <?php echo $_LANG['AD_PHOTO_BY_ARTICLES']; ?> </span> </div>
						
                        <select name="album_id" id="album_id" onchange="choosePhotoAlbum()">
							<option value="0" <?php if (empty($mod['photoalbum']['id'])) { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_DONT_CONNECT']; ?> </option>
							<?php  //FIND ROOT
								if (isset($mod['photoalbum']['id'])){
									echo $inCore->getListItemsNS('cms_photo_albums', $mod['photoalbum']['id']);
								} else {
									echo $inCore->getListItemsNS('cms_photo_albums');
								}
							?>
						</select>

						<div id="con_photoalbum" <?php if (empty($mod['photoalbum']['id'])) { echo 'style="display:none;"'; } ?> >
							<div class="tabtitle"> <?php echo $_LANG['AD_TITLE']; ?> <br> <span class="hinttext"> <?php echo $_LANG['AD_OVER_PHOTOS']; ?> </span> </div>
							<input class="fullsize" name="album_header" type="text" id="album_header" value="<?php echo @$mod['photoalbum']['header'];?> ">

                            <div class="tabtitle"> <?php echo $_LANG['AD_PHOTOS_SORT']; ?> </div>
							<select name="album_orderby" id="album_orderby">
								<option value="title" <?php if (@$mod['photoalbum']['orderby']=='title') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_ALPHABET']; ?> </option>
								<option value="pubdate" <?php if (@$mod['photoalbum']['orderby']=='pubdate') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_CALENDAR']; ?> </option>
								<option value="rating" <?php if (@$mod['photoalbum']['orderby']=='rating') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_RATING']; ?> </option>
								<option value="hits" <?php if (@$mod['photoalbum']['orderby']=='hits') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_VIEWS']; ?> </option>
							</select>
							<select name="album_orderto" id="album_orderto">
								<option value="desc" <?php if (@$mod['photoalbum']['orderto']=='desc') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_DECREMENT']; ?> </option>
								<option value="asc" <?php if (@$mod['photoalbum']['orderto']=='asc') { echo 'selected="selected"'; } ?> > <?php echo $_LANG['AD_BY_INCREMENT']; ?> </option>
							</select>
							
							<div class="tabtitle"> <?php echo $_LANG['AD_HOW_MANY_COLUMNS']; ?> </div>
							<?php if(empty($mod['photoalbum']['maxcols'])) { $mod['photoalbum']['maxcols'] = 2; } ?>
							<input class="fullsize" name="album_maxcols" type="text" id="album_maxcols" value="<?php echo @$mod['photoalbum']['maxcols']; ?> ">

                            <div class="tabtitle"> <?php echo $_LANG['AD_HOW_MANY_PHOTO']; ?> </div>
							<?php if(empty($mod['photoalbum']['max'])) { $mod['photoalbum']['max'] = 8; } ?>
							<input class="fullsize" name="album_max" type="text" id="album_max" value="<?php echo @$mod['photoalbum']['max']; ?> ">
						</div>

					{tab=SEO}
						<div class="tabtitle">
							<?php echo $_LANG['AD_PAGE_TITLE']; ?> <?php printLangPanel('content_category', @$mod['id'], 'pagetitle'); ?> <br>
							<span class="hinttext"> <?php echo $_LANG['AD_IF_UNKNOWN_PAGETITLE']; ?> </span>
						</div>
                        <input class="fullsize" name="pagetitle" type="text" id="pagetitle" value="<?php if (isset($mod['pagetitle'])) { echo htmlspecialchars($mod['pagetitle']); } ?>">
						
						<div class="tabtitle">
							<?php echo $_LANG['KEYWORDS']; ?> <?php printLangPanel('content_category', @$mod['id'], 'meta_keys'); ?> <br>
							<span class="hinttext"> <?php echo $_LANG['AD_FROM_COMMA']; ?> </span>
						</div>
						<textarea name="meta_keys" rows="4" id="meta_keys"><?php if(isset($mod['meta_keys'])){ echo htmlspecialchars($mod['meta_keys']); } ?></textarea>
						
                        <div class="tabtitle">
							<?php echo $_LANG['DESCRIPTION']; ?> <?php printLangPanel('content_category', @$mod['id'], 'meta_desc'); ?> <br>
							<span class="hinttext"> <?php echo $_LANG['AD_LESS_THAN']; ?> </span>
						</div>
						<textarea name="meta_desc" rows="6" id="meta_desc"><?php if(isset($mod['meta_desc'])){ echo htmlspecialchars($mod['meta_desc']); } ?></textarea>

					{tab= <?php echo $_LANG['AD_RIGHTS']; ?> }
						<div class="tabtitle"> <?php echo $_LANG['AD_USERS_ARTICLES']; ?> <br> <span class="hinttext"> <?php echo $_LANG['AD_IF_SWITCH']; ?> </span> </div>
						<select name="is_public">
							<option value="0" <?php if(!empty($mod['is_public'])){ echo 'selected="selected"'; } ?> > <?php echo $_LANG['NO']; ?> </option>
							<option value="1" <?php if(!empty($mod['is_public']) || $do == 'add'){ echo 'selected="selected"'; } ?> > <?php echo $_LANG['YES']; ?> </option>
						</select>

						<?php if (IS_BILLING){ ?>
							<div class="tabtitle"> <?php echo $_LANG['AD_COST_ARTICLES_ADD']; ?> <br> <span class="hinttext"> <?php echo $_LANG['AD_COST_ARTICLES_BY_DEFAULT']; ?> </span> </div>
							<input type="text" name="cost" value="<?php echo $mod['cost']; ?>" style="width:50px"> <?php echo $_LANG['BILLING_POINT10']; ?>
						<?php } ?>

						<div class="tabtitle"> <?php echo $_LANG['AD_EDITORS_SECTION']; ?> <br> <span class="hinttext"> <?php echo $_LANG['AD_USERS_CAN_ADMIN']; ?> </span> </div>
						<select name="modgrp_id" id="modgrp_id">
							<option value="0" <?php if (!isset($mod['modgrp_id']) || @$mod['modgrp_id']==0) { echo 'selected'; } ?> > <?php echo $_LANG['AD_ONLY_ADMINS']; ?> </option>
							<?php if (@$mod['modgrp_id']) {
								echo $inCore->getListItems('cms_user_groups', $mod['modgrp_id'], 'id', 'ASC', 'is_admin = 0');
							} else {
								echo $inCore->getListItems('cms_user_groups', 0, 'id', 'ASC', 'is_admin = 0');
							} ?>
						</select>
						
						<div class="vfield">
							<?php $sql    = "SELECT * FROM cms_user_groups";
							$result = $inDB->query($sql) ;
							$style  = 'disabled="disabled"';
							$public = 'checked="checked"';

							if ($do == 'edit'){
								$sql2 = "SELECT * FROM cms_content_access WHERE content_id = ".$mod['id']." AND content_type = 'category'";
								$result2 = $inDB->query($sql2);
								$ord = array();

								if ($inDB->num_rows($result2)){
									$public = '';
									$style = '';
									while ($r = $inDB->fetch_assoc($result2)){
										$ord[] = $r['group_id'];
									}
								}
							} ?>

							<input class="checklist" name="is_access" type="checkbox" id="is_public" onclick="checkGroupList()" value="1" <?php echo $public ?> >
							<label for="is_public"> <?php echo $_LANG['AD_SHARE']; ?> </label>
						</div>

						<div class="tabtitle"> <span class="hinttext"> <?php echo $_LANG['AD_IF_NOTED'];?> </span> </div>
						<div id="grp">
							<div class="tabtitle"> <?php echo $_LANG['AD_GROUPS_VIEW']; ?> <br> <span class="hinttext"> <?php echo $_LANG['AD_SELECT_MULTIPLE_CTRL']; ?> </span> </div>
							<?php echo '<select name="showfor[]" id="showin" size="6" multiple="multiple" '.$style.'>';
							if ($inDB->num_rows($result)){
								while ($item = $inDB->fetch_assoc($result)){
									echo '<option value="'.$item['id'].'"';

									if ($do=='edit'){
										if (inArray($ord, $item['id'])){
											echo 'selected="selected"';
										}
									}
									
									echo '>';
									echo $item['title'].'</option>';
								}
							}

							echo '</select>'; ?>
						</div>

					{/tabs}
					
					<?php echo jwTabs(ob_get_clean()); ?>
				</td>
			</tr>
		</table>
		
		<p>
			<input name="add_mod" type="submit" id="add_mod" <?php if ($do=='add') { echo 'value="'.$_LANG['AD_SAVE_SECTION'].'"'; } else { echo 'value="'.$_LANG['AD_SAVE_SECTION'].'"'; } ?> >
			<input name="back" type="button" id="back" value="<?php echo $_LANG['CANCEL']; ?>" onclick="window.history.back();">
			<input name="do" type="hidden" id="do" <?php if ($do=='add') { echo 'value="submit"'; } else { echo 'value="update"'; } ?> >
			<?php if ($do=='edit'){
				echo '<input name="id" type="hidden" value="'.$mod['id'].'">';
			} ?>
		</p>

	</form>
	
	<script>
		function choosePhotoAlbum(){
			id = $('select[name=album_id]').val();
			if(id != 0){
				$('#con_photoalbum').fadeIn();
			} else {
				$('#con_photoalbum').hide();
			}
		}
	</script>
<?php }
} ?>