<?php
//
// (с) 2007-2016 InstantCMS Ver 1.10.7, from InstantCMS Team (www.instantcms.ru)
// (c) 2016-202X Public fork iCMS Ver 1.10.7.XXX from InstantCMS members (www.icms.su)
// Licensed by GNU/GPL Ver.2
//

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

class cms_model_banners{

	public function __construct(){
		$this->config = cmsCore::getInstance()->loadComponentConfig('banners');
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public static function getBanner($id){

		$banner = cmsDatabase::getInstance()->get_fields('cms_banners', "id = '$id'", '*');

        if ($banner){
            return cmsCore::callEvent('GET_BANNER', $banner);
        } else {
            return false;
        }

    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public static function getImageBanner($banner){ 

		if($banner['parameters'] != ''){ $parameters = '?'.$banner['parameters'];}else{$parameters = '';}
		if($banner['hide_link'] && !$banner['direct_link']){
			$html = '<span class="banner-link" data-link="/gobanner'.$banner['id'].$parameters.'"';
			$html .= 'title-link="'.$banner['title'].'" src-link="/upload/banners/'.$banner['fileurl'].'" >';
			$html .= '</span>';
		}
		if(!$banner['hide_link'] && $banner['direct_link']){
			$html = '<a href="'.$banner['link'].$parameters.'" title="'.$banner['title'].'" target="_blank">'; 
			$html .= '<img src="/upload/banners/'.$banner['fileurl'].'" alt="'.$banner['title'].'">';
			$html .= '</a>'; 
		}
		if($banner['hide_link'] && $banner['direct_link']){
			$html = '<span class="banner-link" data-link="'.$banner['link'].$parameters.'"';
			$html .= 'title-link="'.$banner['title'].'" src-link="/upload/banners/'.$banner['fileurl'].'" >';
			$html .= '</span>'; 
		}
		if(empty($banner['hide_link']) && empty($banner['direct_link'])){
			$html = '<a href="/gobanner'.$banner['id'].$parameters.'"  title="'.$banner['title'].'" target="_blank">';
			$html .= '<img src="/upload/banners/'.$banner['fileurl'].'" alt="'.$banner['title'].'">';
			$html .= '</a>';
		}

		return $html;

    }

	public static function getSwfBanner($banner){

		return '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0" width="468" height="60">'."\n".
						'<param name="movie" value="/upload/banners/'.$banner['fileurl'].'?banner_id='.$banner['id'].'">'."\n".
						'<param name="quality" value="high">'."\n".
						'<param name="FlashVars" value="banner_id='.$banner['id'].'">'."\n".
						'<embed src="/upload/banners/'.$banner['fileurl'].'?banner_id='.$banner['id'].'" quality="high" pluginspage="http://www.macromedia.com/go/getflashplayer" type="application/x-shockwave-flash" width="468" height="60">'."\n".
						'</embed>'."\n".
					'</object>';

    }

/* ==================================================================================================== */
/* ==================================================================================================== */
    /**
     * Возвращает код баннера по названию позиции
     * Считаются просмотры
     * @param int $id
     * @return html
     */
    public static function getBannerHTML($marker) {

        $inDB   = cmsDatabase::getInstance();
        $inUser = cmsUser::getInstance();

        $marker = $inDB->escape_string($marker);

		$html = '';

	$banner = $inDB->get_fields('cms_banners', "marker = '{$marker}' AND published = 1 AND ((maxhits > hits) OR (maxhits = 0))", '*', 'RAND()');
		
		if(!$banner) { return $html; }

		if ($banner['typeimg']=='image'){
			$html = self::getImageBanner($banner);
		}

		if ($banner['typeimg']=='swf'){
			$html = self::getSwfBanner($banner);
		}

		if ($html) {
            // обновляем статистику просмотра баннера
            $inDB->query("INSERT IGNORE INTO cms_banner_hits (banner_id, ip) VALUES ('{$banner['id']}', '{$inUser->ip}')");
            if($inDB->get_last_id()){
                $inDB->query("UPDATE cms_banners SET hits = hits + 1 WHERE id= '{$banner['id']}'");
            }
        }

        return $html;

    }

/* ==================================================================================================== */
/* ==================================================================================================== */
    /**
     * Возвращает код баннера по ID
     * @param int $id
     * @return html
     */
    public static function getBannerById($id){

        $html = '';

        $banner = self::getBanner($id);
		if(!$banner) { return $html; }

		if ($banner['typeimg']=='image'){
			$html = self::getImageBanner($banner);

		}
		if ($banner['typeimg']=='swf'){
			$html = self::getSwfBanner($banner);
		}

        return $html;
    }

/* ==================================================================================================== */
/* ==================================================================================================== */
    /**
     * Возвращает элементы <option> для списка баннерных позиций
     * @param int $selected
     * @return html
     */
    public static function getBannersListHTML($selected=0){
        $html = '';
        for($bp=1; $bp<=30; $bp++){
            if (@$selected==$bp){
                $s = 'selected';
            } else {
                $s = '';
            }
            $html .= '<option value="banner'.$bp.'" '.$s.'>banner'.$bp.'</option>'."\n";
        }
        return $html;
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public static function clickBanner($id){

        cmsDatabase::getInstance()->query("UPDATE cms_banners SET clicks = clicks + 1 WHERE id = '$id'");

        cmsCore::callEvent('CLICK_BANNER', $id);

        return true;

    }

}