<?php
//
// (с) 2007-2016 InstantCMS Ver 1.10.7, from InstantCMS Team (www.instantcms.ru)
// (c) 2016-202X Public fork iCMS Ver 1.10.7.XXX from InstantCMS members (www.icms.su)
// Licensed by GNU/GPL Ver.2
//

class cmsRegBan {
    
    public function __construct(){
        
        $this->inDB = cmsDatabase::getInstance();
        
    }
    
    public static function getInstance() {
        
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
        
    }
    
    public function errorText($type = 'ip') {
        
        global $_LANG;
        
        if($type == 'ip') {
            return 'Ваш IP заблокирован для регистраций на нашем сайте';
        }
        return 'Ваш Email заблокирован для регистраций на нашем сайте';
        
    }
    
    public function addUserBan($user) {
        
        if($user['id'] == 1) {return true;}
        
        if($user['last_ip'] && !$this->getItem($user['last_ip'], 'value')) {
            $this->addItem(array('type' => 'ip', 'value' => $user['last_ip']));
        }
        if($user['email'] && !$this->getItem($user['email'], 'value')) {
            $this->addItem(array('type' => 'email', 'value' => $user['email']));
        }
        
        //блокируем пользователя
        $this->inDB->update('cms_users', array('is_locked' => 1), $user['id']);
        
        return true;
        
    }
    
    
    public function deleteItem($id) {
        
        return $this->inDB->delete('cms_regbanlist', " id = '$id'", 1);
        
    }
    
    public function addItem($item) {
        
        return $this->inDB->insert('cms_regbanlist', $item);
        
    }
    
    public function updateItem($id, $item){
        
        return $this->inDB->update('cms_regbanlist', $item, $id);

    }
    
    public function getItem($id, $field = 'id') {
        
        return $this->inDB->get_fields('cms_regbanlist', "$field = '$id'", '*');
        
    }
    
    //- NNN.NNN.NNN.NNN
    //- NNN.NNN.NNN.*
    //- NNN.NNN.*
    //- NNN.*
    public function checkIp($ip) {
        
        $ip_array = explode('.', $ip);

        $masks = array();
        $masks[] = $ip;
        $masks[] = $ip_array[0].'.'.$ip_array[1].'.'.$ip_array[2].'.*';
        $masks[] = $ip_array[0].'.'.$ip_array[1].'.*';
        $masks[] = $ip_array[0].'.*';
        
        $is_search = false;
        foreach ($masks as $mask) {
            $sql    = "SELECT value FROM cms_regbanlist WHERE value = '{$mask}' AND type = 'ip'";
            $rs     = $this->inDB->query($sql);
            if ($this->inDB->num_rows($rs)){ $is_search = $this->inDB->fetch_assoc($rs); }
        }
        
        return $is_search;
    }
    
    //    -  name@mail.zone
    //    - *@mail.zone
    //    - *.zone
    public function checkEmail($email) {
        
        $email_array = explode('@', $email);
        $username = $email_array[0];
        $domain_array = explode(".", $email_array[1]);
        $domain = $domain_array[0];
        unset($domain_array[0]);
        $lts = '';
        foreach( $domain_array as $d ) {
          $lts .= '.'.$d;
        }

        $masks = array();
        $masks[] = $email;
        $masks[] = '*@'.$domain.$lts;
        $masks[] = '*'.$lts;
        
        $is_search = false;
        foreach ($masks as $mask) {
            $sql    = "SELECT value FROM cms_regbanlist WHERE value = '{$mask}' AND type = 'email'";
            $rs     = $this->inDB->query($sql);
            if ($this->inDB->num_rows($rs)){ $is_search = $this->inDB->fetch_assoc($rs); continue; }
        }
        
        return $is_search;
    }
    

}